package fr.enssat.BoulderDash.controllers;

import fr.enssat.BoulderDash.exceptions.LevelConstraintNotRespectedException;
import fr.enssat.BoulderDash.helpers.AudioLoadHelper;
import fr.enssat.BoulderDash.models.LevelModel;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

public abstract class GameModuleController implements ActionListener {
    private LevelModel levelModel;
    private NavigationBetweenViewController nav;

    public GameModuleController(LevelModel levelModel, NavigationBetweenViewController nav) {
        this.levelModel = levelModel;
        this.nav = nav;
    }

    public abstract void actionPerformed(ActionEvent event);

    /**
     * Gets level model
     *
     * @return Level model
     */
    public LevelModel getLevelModel() {
        return this.levelModel;
    }

    protected void menuActionPerformed() {
        this.nav.setMenuView();
        this.nav.getAudioLoadHelper().startMusic("game");
    }

    protected void resetLevelModel(AudioLoadHelper audioLoadHelper) {
        this.levelModel = new LevelModel(this.nav.getPickedLevelIdentifier(), audioLoadHelper);
    }
}
