package fr.enssat.BoulderDash.controllers;

import fr.enssat.BoulderDash.models.LevelModel;

import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;

public abstract class KeyController implements KeyListener {
    private LevelModel levelModel;

    public KeyController(LevelModel levelModel) {
        this.levelModel = levelModel;
    }

    /**
     * Handles the 'key pressed' event
     *
     * @param  e  Key event
     */
    public abstract void keyPressed(KeyEvent e);

    /**
     * Handles the 'key released' event
     *
     * @param  e  Key event
     */
    @Override
    public abstract void keyReleased(KeyEvent e);

    /**
     * Handles the 'key typed' event
     *
     * @param  e  Key event
     */
    @Override
    public abstract void keyTyped(KeyEvent e);

    public LevelModel getLevelModel() {
        return levelModel;
    }
}
